;Critical AH constants:

;Maximum threads of the target process that can be opened, suspended
;and used by RemoteExec9x (RemoteExec9x doesn't fail if process has
;more threads but they aren't stopped). This constant will have sense
;in the future for robust database processes.
MAX_HTIDTHREAD         = 64     ;threads ~ dwords

;Maximum modules in the target process that can be hooked (AH doesn't
;fail if target contains more modules but they aren't hooked). This
;constant will have sense in the future for robust database processes.
MAXMODULES             = 128    ;modules ~ dwords

;Initial size of the buffer for
;NtQuerySystemInformation(SystemProcessInformation,...)
;This constant will have sense in the future for robust systems.
START_SIZE_FOR_NTQUERY = 5000H  ;bytes
;If the buffer was not big enough it will be freed and will be allocated
;buffer of the size = previous_size +
DELTA_SIZE_FOR_NTQUERY = 1000H  ;bytes

;Time for Module functions (LoadAndCall, UnloadModule, IsModuleLoaded)
;they should pass to RemoteExec (if there's not enough time it may lead
;to timeout errors)
MODULE_TIME            = 30000  ;milliseconds

;For ApiHooks.exe, resp. FindProcessNT5
;How many processes with the same base name can be present in the system
;(it is not critical but if there are more candidates they will not be
;taken into account)
MAX_PIDs               = 127    ;processes ~ dwords